annotate src/flac-1.2.1/install-sh @ 169:223a55898ab9 tip default

Add null config files
author Chris Cannam <cannam@all-day-breakfast.com>
date Mon, 02 Mar 2020 14:03:47 +0000
parents 98c1576536ae
children
rev   line source
cannam@86 1 #!/bin/sh
cannam@86 2 #
cannam@86 3 # install - install a program, script, or datafile
cannam@86 4 #
cannam@86 5 # This originates from X11R5 (mit/util/scripts/install.sh), which was
cannam@86 6 # later released in X11R6 (xc/config/util/install.sh) with the
cannam@86 7 # following copyright and license.
cannam@86 8 #
cannam@86 9 # Copyright (C) 1994 X Consortium
cannam@86 10 #
cannam@86 11 # Permission is hereby granted, free of charge, to any person obtaining a copy
cannam@86 12 # of this software and associated documentation files (the "Software"), to
cannam@86 13 # deal in the Software without restriction, including without limitation the
cannam@86 14 # rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
cannam@86 15 # sell copies of the Software, and to permit persons to whom the Software is
cannam@86 16 # furnished to do so, subject to the following conditions:
cannam@86 17 #
cannam@86 18 # The above copyright notice and this permission notice shall be included in
cannam@86 19 # all copies or substantial portions of the Software.
cannam@86 20 #
cannam@86 21 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
cannam@86 22 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
cannam@86 23 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
cannam@86 24 # X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
cannam@86 25 # AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
cannam@86 26 # TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
cannam@86 27 #
cannam@86 28 # Except as contained in this notice, the name of the X Consortium shall not
cannam@86 29 # be used in advertising or otherwise to promote the sale, use or other deal-
cannam@86 30 # ings in this Software without prior written authorization from the X Consor-
cannam@86 31 # tium.
cannam@86 32 #
cannam@86 33 #
cannam@86 34 # FSF changes to this file are in the public domain.
cannam@86 35 #
cannam@86 36 # Calling this script install-sh is preferred over install.sh, to prevent
cannam@86 37 # `make' implicit rules from creating a file called install from it
cannam@86 38 # when there is no Makefile.
cannam@86 39 #
cannam@86 40 # This script is compatible with the BSD install script, but was written
cannam@86 41 # from scratch. It can only install one file at a time, a restriction
cannam@86 42 # shared with many OS's install programs.
cannam@86 43
cannam@86 44
cannam@86 45 # set DOITPROG to echo to test this script
cannam@86 46
cannam@86 47 # Don't use :- since 4.3BSD and earlier shells don't like it.
cannam@86 48 doit="${DOITPROG-}"
cannam@86 49
cannam@86 50
cannam@86 51 # put in absolute paths if you don't have them in your path; or use env. vars.
cannam@86 52
cannam@86 53 mvprog="${MVPROG-mv}"
cannam@86 54 cpprog="${CPPROG-cp}"
cannam@86 55 chmodprog="${CHMODPROG-chmod}"
cannam@86 56 chownprog="${CHOWNPROG-chown}"
cannam@86 57 chgrpprog="${CHGRPPROG-chgrp}"
cannam@86 58 stripprog="${STRIPPROG-strip}"
cannam@86 59 rmprog="${RMPROG-rm}"
cannam@86 60 mkdirprog="${MKDIRPROG-mkdir}"
cannam@86 61
cannam@86 62 transformbasename=""
cannam@86 63 transform_arg=""
cannam@86 64 instcmd="$mvprog"
cannam@86 65 chmodcmd="$chmodprog 0755"
cannam@86 66 chowncmd=""
cannam@86 67 chgrpcmd=""
cannam@86 68 stripcmd=""
cannam@86 69 rmcmd="$rmprog -f"
cannam@86 70 mvcmd="$mvprog"
cannam@86 71 src=""
cannam@86 72 dst=""
cannam@86 73 dir_arg=""
cannam@86 74
cannam@86 75 while [ x"$1" != x ]; do
cannam@86 76 case $1 in
cannam@86 77 -c) instcmd=$cpprog
cannam@86 78 shift
cannam@86 79 continue;;
cannam@86 80
cannam@86 81 -d) dir_arg=true
cannam@86 82 shift
cannam@86 83 continue;;
cannam@86 84
cannam@86 85 -m) chmodcmd="$chmodprog $2"
cannam@86 86 shift
cannam@86 87 shift
cannam@86 88 continue;;
cannam@86 89
cannam@86 90 -o) chowncmd="$chownprog $2"
cannam@86 91 shift
cannam@86 92 shift
cannam@86 93 continue;;
cannam@86 94
cannam@86 95 -g) chgrpcmd="$chgrpprog $2"
cannam@86 96 shift
cannam@86 97 shift
cannam@86 98 continue;;
cannam@86 99
cannam@86 100 -s) stripcmd=$stripprog
cannam@86 101 shift
cannam@86 102 continue;;
cannam@86 103
cannam@86 104 -t=*) transformarg=`echo $1 | sed 's/-t=//'`
cannam@86 105 shift
cannam@86 106 continue;;
cannam@86 107
cannam@86 108 -b=*) transformbasename=`echo $1 | sed 's/-b=//'`
cannam@86 109 shift
cannam@86 110 continue;;
cannam@86 111
cannam@86 112 *) if [ x"$src" = x ]
cannam@86 113 then
cannam@86 114 src=$1
cannam@86 115 else
cannam@86 116 # this colon is to work around a 386BSD /bin/sh bug
cannam@86 117 :
cannam@86 118 dst=$1
cannam@86 119 fi
cannam@86 120 shift
cannam@86 121 continue;;
cannam@86 122 esac
cannam@86 123 done
cannam@86 124
cannam@86 125 if [ x"$src" = x ]
cannam@86 126 then
cannam@86 127 echo "$0: no input file specified" >&2
cannam@86 128 exit 1
cannam@86 129 else
cannam@86 130 :
cannam@86 131 fi
cannam@86 132
cannam@86 133 if [ x"$dir_arg" != x ]; then
cannam@86 134 dst=$src
cannam@86 135 src=""
cannam@86 136
cannam@86 137 if [ -d "$dst" ]; then
cannam@86 138 instcmd=:
cannam@86 139 chmodcmd=""
cannam@86 140 else
cannam@86 141 instcmd=$mkdirprog
cannam@86 142 fi
cannam@86 143 else
cannam@86 144
cannam@86 145 # Waiting for this to be detected by the "$instcmd $src $dsttmp" command
cannam@86 146 # might cause directories to be created, which would be especially bad
cannam@86 147 # if $src (and thus $dsttmp) contains '*'.
cannam@86 148
cannam@86 149 if [ -f "$src" ] || [ -d "$src" ]
cannam@86 150 then
cannam@86 151 :
cannam@86 152 else
cannam@86 153 echo "$0: $src does not exist" >&2
cannam@86 154 exit 1
cannam@86 155 fi
cannam@86 156
cannam@86 157 if [ x"$dst" = x ]
cannam@86 158 then
cannam@86 159 echo "$0: no destination specified" >&2
cannam@86 160 exit 1
cannam@86 161 else
cannam@86 162 :
cannam@86 163 fi
cannam@86 164
cannam@86 165 # If destination is a directory, append the input filename; if your system
cannam@86 166 # does not like double slashes in filenames, you may need to add some logic
cannam@86 167
cannam@86 168 if [ -d "$dst" ]
cannam@86 169 then
cannam@86 170 dst=$dst/`basename "$src"`
cannam@86 171 else
cannam@86 172 :
cannam@86 173 fi
cannam@86 174 fi
cannam@86 175
cannam@86 176 ## this sed command emulates the dirname command
cannam@86 177 dstdir=`echo "$dst" | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
cannam@86 178
cannam@86 179 # Make sure that the destination directory exists.
cannam@86 180 # this part is taken from Noah Friedman's mkinstalldirs script
cannam@86 181
cannam@86 182 # Skip lots of stat calls in the usual case.
cannam@86 183 if [ ! -d "$dstdir" ]; then
cannam@86 184 defaultIFS='
cannam@86 185 '
cannam@86 186 IFS="${IFS-$defaultIFS}"
cannam@86 187
cannam@86 188 oIFS=$IFS
cannam@86 189 # Some sh's can't handle IFS=/ for some reason.
cannam@86 190 IFS='%'
cannam@86 191 set - `echo "$dstdir" | sed -e 's@/@%@g' -e 's@^%@/@'`
cannam@86 192 IFS=$oIFS
cannam@86 193
cannam@86 194 pathcomp=''
cannam@86 195
cannam@86 196 while [ $# -ne 0 ] ; do
cannam@86 197 pathcomp=$pathcomp$1
cannam@86 198 shift
cannam@86 199
cannam@86 200 if [ ! -d "$pathcomp" ] ;
cannam@86 201 then
cannam@86 202 $mkdirprog "$pathcomp"
cannam@86 203 else
cannam@86 204 :
cannam@86 205 fi
cannam@86 206
cannam@86 207 pathcomp=$pathcomp/
cannam@86 208 done
cannam@86 209 fi
cannam@86 210
cannam@86 211 if [ x"$dir_arg" != x ]
cannam@86 212 then
cannam@86 213 $doit $instcmd "$dst" &&
cannam@86 214
cannam@86 215 if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dst"; else : ; fi &&
cannam@86 216 if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dst"; else : ; fi &&
cannam@86 217 if [ x"$stripcmd" != x ]; then $doit $stripcmd "$dst"; else : ; fi &&
cannam@86 218 if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dst"; else : ; fi
cannam@86 219 else
cannam@86 220
cannam@86 221 # If we're going to rename the final executable, determine the name now.
cannam@86 222
cannam@86 223 if [ x"$transformarg" = x ]
cannam@86 224 then
cannam@86 225 dstfile=`basename "$dst"`
cannam@86 226 else
cannam@86 227 dstfile=`basename "$dst" $transformbasename |
cannam@86 228 sed $transformarg`$transformbasename
cannam@86 229 fi
cannam@86 230
cannam@86 231 # don't allow the sed command to completely eliminate the filename
cannam@86 232
cannam@86 233 if [ x"$dstfile" = x ]
cannam@86 234 then
cannam@86 235 dstfile=`basename "$dst"`
cannam@86 236 else
cannam@86 237 :
cannam@86 238 fi
cannam@86 239
cannam@86 240 # Make a couple of temp file names in the proper directory.
cannam@86 241
cannam@86 242 dsttmp=$dstdir/_inst.$$_
cannam@86 243 rmtmp=$dstdir/_rm.$$_
cannam@86 244
cannam@86 245 # Trap to clean up temp files at exit.
cannam@86 246
cannam@86 247 trap 'status=$?; rm -f "$dsttmp" "$rmtmp" && exit $status' 0
cannam@86 248 trap '(exit $?); exit' 1 2 13 15
cannam@86 249
cannam@86 250 # Move or copy the file name to the temp name
cannam@86 251
cannam@86 252 $doit $instcmd "$src" "$dsttmp" &&
cannam@86 253
cannam@86 254 # and set any options; do chmod last to preserve setuid bits
cannam@86 255
cannam@86 256 # If any of these fail, we abort the whole thing. If we want to
cannam@86 257 # ignore errors from any of these, just make sure not to ignore
cannam@86 258 # errors from the above "$doit $instcmd $src $dsttmp" command.
cannam@86 259
cannam@86 260 if [ x"$chowncmd" != x ]; then $doit $chowncmd "$dsttmp"; else :;fi &&
cannam@86 261 if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd "$dsttmp"; else :;fi &&
cannam@86 262 if [ x"$stripcmd" != x ]; then $doit $stripcmd "$dsttmp"; else :;fi &&
cannam@86 263 if [ x"$chmodcmd" != x ]; then $doit $chmodcmd "$dsttmp"; else :;fi &&
cannam@86 264
cannam@86 265 # Now remove or move aside any old file at destination location. We try this
cannam@86 266 # two ways since rm can't unlink itself on some systems and the destination
cannam@86 267 # file might be busy for other reasons. In this case, the final cleanup
cannam@86 268 # might fail but the new file should still install successfully.
cannam@86 269
cannam@86 270 {
cannam@86 271 if [ -f "$dstdir/$dstfile" ]
cannam@86 272 then
cannam@86 273 $doit $rmcmd -f "$dstdir/$dstfile" 2>/dev/null ||
cannam@86 274 $doit $mvcmd -f "$dstdir/$dstfile" "$rmtmp" 2>/dev/null ||
cannam@86 275 {
cannam@86 276 echo "$0: cannot unlink or rename $dstdir/$dstfile" >&2
cannam@86 277 (exit 1); exit
cannam@86 278 }
cannam@86 279 else
cannam@86 280 :
cannam@86 281 fi
cannam@86 282 } &&
cannam@86 283
cannam@86 284 # Now rename the file to the real destination.
cannam@86 285
cannam@86 286 $doit $mvcmd "$dsttmp" "$dstdir/$dstfile"
cannam@86 287
cannam@86 288 fi &&
cannam@86 289
cannam@86 290 # The final little trick to "correctly" pass the exit status to the exit trap.
cannam@86 291
cannam@86 292 {
cannam@86 293 (exit 0); exit
cannam@86 294 }